package cn.com.qmth.examcloud.starters.face.verify.test;

import cn.com.qmth.examcloud.starters.face.verify.FaceVerifyProperties;
import cn.com.qmth.examcloud.starters.face.verify.model.FaceResult;
import cn.com.qmth.examcloud.starters.face.verify.common.JsonHelper;
import cn.com.qmth.examcloud.starters.face.verify.model.param.ImageFileParm;
import cn.com.qmth.examcloud.starters.face.verify.model.param.ImageParm;
import cn.com.qmth.examcloud.starters.face.verify.model.param.ImageUrlParm;
import cn.com.qmth.examcloud.starters.face.verify.service.impl.FaceVerifyServiceImpl;

import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class FaceApiTest {

    // @Test
    public void demo() throws Exception {
        FaceVerifyProperties properties = new FaceVerifyProperties();
        properties.setFacePlusKey("xxx");
        properties.setFacePlusSecret("xxx");
        properties.setBaiduKey("xxx");
        properties.setBaiduSecret("xxx");
        properties.setBaiduLocalEnabled(true);
        properties.setBaiduLocalAppId("test");
        properties.setBaiduLocalUrlPrefix("http://192.168.10.102:8301");
        // properties.setBaiduLocalUrlPrefix("http://192.168.0.117:8300");
        // properties.setBaiduExpectFaceCompareScore(70d);

        FaceVerifyServiceImpl faceVerifyService = new FaceVerifyServiceImpl();
        faceVerifyService.setProperties(properties);

        String image1 = "https://img0.baidu.com/it/u=2750657437,2761718651&fm=253&fmt=auto&app=138&f=JPEG?w=500&h=749";
        String image2 = "https://img2.baidu.com/it/u=1657567997,3247312681&fm=253&fmt=auto&app=138&f=JPEG?w=500&h=666";
        String image3 = "https://img0.baidu.com/it/u=3045244088,3053373141&fm=253&fmt=auto&app=138&f=JPEG?w=200&h=200";
        String image4 = "https://img2.baidu.com/it/u=529672263,3841026141&fm=253&fmt=auto&app=138&f=JPEG?w=200&h=200";
        String image5 = "D:\\home\\test\\101.jpg";
        String image6 = "D:\\home\\test\\102.jpg";

        ImageParm imageParm = new ImageUrlParm(image3);
        ImageParm imageParm2 = new ImageUrlParm(image4);
        ImageParm imageParm3 = new ImageFileParm(image5);
        ImageParm imageParm4 = new ImageFileParm(image6);
        FaceResult result = faceVerifyService.faceVerifyByBaidu(imageParm);
        // FaceResult result = faceVerifyService.faceDetectByBaidu(imageParm);
        // FaceResult result = faceVerifyService.faceCompareByBaidu(imageParm, imageParm2);
        // FaceResult result = faceVerifyService.faceDetectByFacePlus(imageParm);
        // FaceResult result = faceVerifyService.faceCompareByFacePlus(imageParm, imageParm2);
        System.out.println("==================================================");
        System.out.println(new JsonHelper().toJson(result));

        // concurrentTest(faceVerifyService, imageParm);
    }

    private void concurrentTest(FaceVerifyServiceImpl faceVerifyService, ImageParm image) {
        int threadNum = 20;
        ExecutorService service = Executors.newCachedThreadPool();
        final CountDownLatch commander = new CountDownLatch(1);
        final CountDownLatch worker = new CountDownLatch(threadNum);

        for (int n = 0; n < threadNum; n++) {
            Runnable runnable = () -> {
                try {
                    FaceResult res = faceVerifyService.faceVerifyByBaidu(image);
                    System.out.println("线程：" + Thread.currentThread().getName() + " 结果：" + new JsonHelper().toJson(res) + "\n");
                } catch (Exception e) {
                    e.printStackTrace();
                } finally {
                    worker.countDown();
                }
            };
            service.execute(runnable);
        }

        try {
            commander.countDown();
            worker.await();
        } catch (Exception e) {
            e.printStackTrace();
        }

        service.shutdown();
    }

}
